/* gpx-playback.c generated by valac, the Vala compiler
 * generated from gpx-playback.vala, do not modify */

/* Gpx Viewer
 * Copyright (C) 2009-2009 Qball Cow <qball@sarine.nl>
 * Project homepage: http://blog.sarine.nl/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <float.h>
#include <math.h>
#include <time.h>


#define GPX_TYPE_PLAYBACK (gpx_playback_get_type ())
#define GPX_PLAYBACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_PLAYBACK, GpxPlayback))
#define GPX_PLAYBACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_PLAYBACK, GpxPlaybackClass))
#define GPX_IS_PLAYBACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_PLAYBACK))
#define GPX_IS_PLAYBACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_PLAYBACK))
#define GPX_PLAYBACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_PLAYBACK, GpxPlaybackClass))

typedef struct _GpxPlayback GpxPlayback;
typedef struct _GpxPlaybackClass GpxPlaybackClass;
typedef struct _GpxPlaybackPrivate GpxPlaybackPrivate;

#define GPX_TYPE_TRACK (gpx_track_get_type ())
#define GPX_TRACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_TRACK, GpxTrack))
#define GPX_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_TRACK, GpxTrackClass))
#define GPX_IS_TRACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_TRACK))
#define GPX_IS_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_TRACK))
#define GPX_TRACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_TRACK, GpxTrackClass))

typedef struct _GpxTrack GpxTrack;
typedef struct _GpxTrackClass GpxTrackClass;

#define GPX_TYPE_POINT (gpx_point_get_type ())
#define GPX_POINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_POINT, GpxPoint))
#define GPX_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_POINT, GpxPointClass))
#define GPX_IS_POINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_POINT))
#define GPX_IS_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_POINT))
#define GPX_POINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_POINT, GpxPointClass))

typedef struct _GpxPoint GpxPoint;
typedef struct _GpxPointClass GpxPointClass;

#define GPX_PLAYBACK_TYPE_STATE (gpx_playback_state_get_type ())
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL)))
typedef struct _GpxTrackPrivate GpxTrackPrivate;

struct _GpxPlayback {
	GObject parent_instance;
	GpxPlaybackPrivate * priv;
};

struct _GpxPlaybackClass {
	GObjectClass parent_class;
};

struct _GpxPlaybackPrivate {
	GTimer* progress;
	GpxTrack* track;
	guint timer;
	GList* current;
	GpxPoint* first;
	gint _speedup;
};

typedef enum  {
	GPX_PLAYBACK_STATE_STOPPED,
	GPX_PLAYBACK_STATE_PAUSED,
	GPX_PLAYBACK_STATE_PLAY
} GpxPlaybackState;

struct _GpxTrack {
	GObject parent_instance;
	GpxTrackPrivate * priv;
	double total_distance;
	double max_speed;
	GList* points;
	GpxPoint* top;
	GpxPoint* bottom;
	double max_elevation;
	double min_elevation;
};

struct _GpxTrackClass {
	GObjectClass parent_class;
};


static gpointer gpx_playback_parent_class = NULL;

#define GT_LOG_DOMAIN "GPX_PLAYBACK"
#define gt_unique_graph VERSION
GType gpx_playback_get_type (void) G_GNUC_CONST;
GType gpx_track_get_type (void) G_GNUC_CONST;
gpointer gpx_point_ref (gpointer instance);
void gpx_point_unref (gpointer instance);
GParamSpec* gpx_param_spec_point (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gpx_value_set_point (GValue* value, gpointer v_object);
void gpx_value_take_point (GValue* value, gpointer v_object);
gpointer gpx_value_get_point (const GValue* value);
GType gpx_point_get_type (void) G_GNUC_CONST;
#define GPX_PLAYBACK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_PLAYBACK, GpxPlaybackPrivate))
enum  {
	GPX_PLAYBACK_DUMMY_PROPERTY,
	GPX_PLAYBACK_SPEEDUP
};
GType gpx_playback_state_get_type (void) G_GNUC_CONST;
void gpx_playback_stop (GpxPlayback* self);
void gpx_playback_set_track (GpxPlayback* self, GpxTrack* track);
GpxPlayback* gpx_playback_new (GpxTrack* track);
GpxPlayback* gpx_playback_construct (GType object_type, GpxTrack* track);
time_t gpx_point_get_time (GpxPoint* self);
gboolean gpx_playback_timer_callback (GpxPlayback* self);
static gboolean _gpx_playback_timer_callback_gsource_func (gpointer self);
void gpx_playback_start (GpxPlayback* self);
void gpx_playback_pause (GpxPlayback* self);
gint gpx_playback_get_speedup (GpxPlayback* self);
void gpx_playback_set_speedup (GpxPlayback* self, gint value);
static void gpx_playback_finalize (GObject* obj);
static void gpx_playback_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void gpx_playback_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void g_cclosure_user_marshal_VOID__GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

GType gpx_playback_state_get_type (void) {
	static volatile gsize gpx_playback_state_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_playback_state_type_id__volatile)) {
		static const GEnumValue values[] = {{GPX_PLAYBACK_STATE_STOPPED, "GPX_PLAYBACK_STATE_STOPPED", "stopped"}, {GPX_PLAYBACK_STATE_PAUSED, "GPX_PLAYBACK_STATE_PAUSED", "paused"}, {GPX_PLAYBACK_STATE_PLAY, "GPX_PLAYBACK_STATE_PLAY", "play"}, {0, NULL, NULL}};
		GType gpx_playback_state_type_id;
		gpx_playback_state_type_id = g_enum_register_static ("GpxPlaybackState", values);
		g_once_init_leave (&gpx_playback_state_type_id__volatile, gpx_playback_state_type_id);
	}
	return gpx_playback_state_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gpointer _gpx_point_ref0 (gpointer self) {
	return self ? gpx_point_ref (self) : NULL;
}


void gpx_playback_set_track (GpxPlayback* self, GpxTrack* track) {
	GpxTrack* _tmp0_;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (self != NULL);
	gpx_playback_stop (self);
	self->priv->track = (_tmp0_ = _g_object_ref0 (track), _g_object_unref0 (self->priv->track), _tmp0_);
	if (self->priv->track != NULL) {
		_tmp1_ = self->priv->track->points != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GpxPoint* _tmp2_;
		self->priv->first = (_tmp2_ = _gpx_point_ref0 ((GpxPoint*) g_list_first (self->priv->track->points)->data), _gpx_point_unref0 (self->priv->first), _tmp2_);
	}
}


GpxPlayback* gpx_playback_construct (GType object_type, GpxTrack* track) {
	GpxPlayback * self;
	GpxTrack* _tmp0_;
	gboolean _tmp1_ = FALSE;
	self = (GpxPlayback*) g_object_new (object_type, NULL);
	self->priv->track = (_tmp0_ = _g_object_ref0 (track), _g_object_unref0 (self->priv->track), _tmp0_);
	if (self->priv->track != NULL) {
		_tmp1_ = self->priv->track->points != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		GpxPoint* _tmp2_;
		self->priv->first = (_tmp2_ = _gpx_point_ref0 ((GpxPoint*) g_list_first (self->priv->track->points)->data), _gpx_point_unref0 (self->priv->first), _tmp2_);
	}
	return self;
}


GpxPlayback* gpx_playback_new (GpxTrack* track) {
	return gpx_playback_construct (GPX_TYPE_PLAYBACK, track);
}


gboolean gpx_playback_timer_callback (GpxPlayback* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->current == NULL) {
		g_timer_stop (self->priv->progress);
		g_timer_reset (self->priv->progress);
		g_signal_emit_by_name (self, "state-changed", GPX_PLAYBACK_STATE_STOPPED);
		g_signal_emit_by_name (self, "tick", NULL);
		result = FALSE;
		return result;
	}
	if (gpx_point_get_time ((GpxPoint*) self->priv->current->data) > (gpx_point_get_time (self->priv->first) + (self->priv->_speedup * g_timer_elapsed (self->priv->progress, NULL)))) {
		result = TRUE;
		return result;
	}
	g_signal_emit_by_name (self, "tick", (GpxPoint*) self->priv->current->data);
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		if (self->priv->current != NULL) {
			_tmp0_ = gpx_point_get_time ((GpxPoint*) self->priv->current->data) < (gpx_point_get_time (self->priv->first) + (self->priv->_speedup * g_timer_elapsed (self->priv->progress, NULL)));
		} else {
			_tmp0_ = FALSE;
		}
		if (!_tmp0_) {
			break;
		}
		self->priv->current = self->priv->current->next;
	}
	result = TRUE;
	return result;
}


static gboolean _gpx_playback_timer_callback_gsource_func (gpointer self) {
	gboolean result;
	result = gpx_playback_timer_callback (self);
	return result;
}


void gpx_playback_start (GpxPlayback* self) {
	g_return_if_fail (self != NULL);
	gpx_playback_stop (self);
	if (self->priv->first != NULL) {
		g_timer_start (self->priv->progress);
		g_signal_emit_by_name (self, "state-changed", GPX_PLAYBACK_STATE_PLAY);
		g_debug ("gpx-playback.vala:97: start playback\n");
		self->priv->current = g_list_first (self->priv->track->points);
		self->priv->timer = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _gpx_playback_timer_callback_gsource_func, g_object_ref (self), g_object_unref);
	}
}


void gpx_playback_pause (GpxPlayback* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->current == NULL) {
		return;
	}
	if (self->priv->timer > 0) {
		g_source_remove (self->priv->timer);
		self->priv->timer = (guint) 0;
		g_timer_stop (self->priv->progress);
		g_signal_emit_by_name (self, "state-changed", GPX_PLAYBACK_STATE_PAUSED);
	} else {
		self->priv->timer = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, _gpx_playback_timer_callback_gsource_func, g_object_ref (self), g_object_unref);
		g_timer_continue (self->priv->progress);
		g_signal_emit_by_name (self, "state-changed", GPX_PLAYBACK_STATE_PLAY);
	}
}


void gpx_playback_stop (GpxPlayback* self) {
	g_return_if_fail (self != NULL);
	if (self->priv->timer > 0) {
		g_debug ("gpx-playback.vala:119: stop playback\n");
		g_source_remove (self->priv->timer);
		self->priv->timer = (guint) 0;
		g_timer_stop (self->priv->progress);
		g_timer_reset (self->priv->progress);
		g_signal_emit_by_name (self, "state-changed", GPX_PLAYBACK_STATE_STOPPED);
	}
	g_signal_emit_by_name (self, "tick", NULL);
}


gint gpx_playback_get_speedup (GpxPlayback* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_speedup;
	return result;
}


void gpx_playback_set_speedup (GpxPlayback* self, gint value) {
	g_return_if_fail (self != NULL);
	gpx_playback_pause (self);
	self->priv->_speedup = value;
	gpx_playback_pause (self);
	g_object_notify ((GObject *) self, "speedup");
}


static void gpx_playback_class_init (GpxPlaybackClass * klass) {
	gpx_playback_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GpxPlaybackPrivate));
	G_OBJECT_CLASS (klass)->get_property = gpx_playback_get_property;
	G_OBJECT_CLASS (klass)->set_property = gpx_playback_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpx_playback_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_PLAYBACK_SPEEDUP, g_param_spec_int ("speedup", "speedup", "speedup", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("tick", GPX_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__GPX_POINT, G_TYPE_NONE, 1, GPX_TYPE_POINT);
	g_signal_new ("state_changed", GPX_TYPE_PLAYBACK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, GPX_PLAYBACK_TYPE_STATE);
}


static void gpx_playback_instance_init (GpxPlayback * self) {
	self->priv = GPX_PLAYBACK_GET_PRIVATE (self);
	self->priv->progress = g_timer_new ();
	self->priv->track = NULL;
	self->priv->timer = (guint) 0;
	self->priv->first = NULL;
	self->priv->_speedup = 50;
}


static void gpx_playback_finalize (GObject* obj) {
	GpxPlayback * self;
	self = GPX_PLAYBACK (obj);
	_g_timer_destroy0 (self->priv->progress);
	_g_object_unref0 (self->priv->track);
	_gpx_point_unref0 (self->priv->first);
	G_OBJECT_CLASS (gpx_playback_parent_class)->finalize (obj);
}


GType gpx_playback_get_type (void) {
	static volatile gsize gpx_playback_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_playback_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpxPlaybackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_playback_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxPlayback), 0, (GInstanceInitFunc) gpx_playback_instance_init, NULL };
		GType gpx_playback_type_id;
		gpx_playback_type_id = g_type_register_static (G_TYPE_OBJECT, "GpxPlayback", &g_define_type_info, 0);
		g_once_init_leave (&gpx_playback_type_id__volatile, gpx_playback_type_id);
	}
	return gpx_playback_type_id__volatile;
}


static void gpx_playback_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GpxPlayback * self;
	self = GPX_PLAYBACK (object);
	switch (property_id) {
		case GPX_PLAYBACK_SPEEDUP:
		g_value_set_int (value, gpx_playback_get_speedup (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gpx_playback_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GpxPlayback * self;
	self = GPX_PLAYBACK (object);
	switch (property_id) {
		case GPX_PLAYBACK_SPEEDUP:
		gpx_playback_set_speedup (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



static void g_cclosure_user_marshal_VOID__GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__GPX_POINT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__GPX_POINT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__GPX_POINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, gpx_value_get_point (param_values + 1), data2);
}



